/*
 *
 * Copyright (c) 2004  DMC Co., Ltd.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
 * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 * Except as contained in this notice, the name of the DMC Co., Ltd shall not 
 * be used in advertising or otherwise to promote the sale, use or other dealings
 * in this Software without prior written authorization from DMC Co., Ltd.
 */
/*
 * EUC
 * tab=4
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <sys/wait.h>
#include "tb.h"
#include "../driver/cmd.h"
#include "../vers.h"

#define TEST_RMMOD	1

int main(int argc,char *argv[]);
void prhelp();
void domain();

int snum = 0;
static Display *sDisp;
char *path;

/*
*/
char *idstr[] = { "Panel ID Setting","id=0","id=1",0 };

int main(int argc,char *argv[])
{
int i,k;
	setbuf(stdin,0);
	setbuf(stdout,0);
	snum = 0;
	path = NULL;
	for( k=0,i=1 ; i < argc ; i++ )
	{
		if( argv[i][0] == '-' )
		{
			switch( argv[i][1] )
			{
			case	0:		k++;					break;
			default:		prhelp();				break;
			}
		}
		else
		{
			switch( k )
			{
			case	0:	path = argv[i];	break;
			}
			k++;
		}
	}
	domain();
	return(0);
}
void prhelp()
{
	fprintf(stderr,"Syntax:tbidset {<Option>} \n");
	fprintf(stderr,"Function: %s DMC touch-panel usb-iProduct change on X-Window\n",ProductName);
	fprintf(stderr,"Option:\n");
	fprintf(stderr,"    -?     help\n");
	exit(0);
}

void domain()
{
uWindowPtr win;
uColor fgcolor,bgcolor;
int btnum[20];
#define	BTNUM_APPLY		0
uControlPtr ctl[50];
int ctlnum;
XEvent ev;
Cursor cs;
uRect r;
int end,i,x,y,w,h,ww,y1,win_w,win_h;
KeySym key;
char s[100];
int sn,id;
int lineh;
uPoint mpt;
	init_ulib();
	sDisp = set_port(snum);
	mpt.x = 100;
	mpt.y = 100;
	if( (i=open_xinput_driver("DMC")) < 0 )
	{
		msgbox("idset-result","ERROR!! TSC-xx is two!",MB_OK,&mpt);
		return;
	}
	id = 0;
	if( gScreenCount >= 2 )
	{
		sn = -1;
		w = 0;
		for( i=0 ; i < MAX_SCREEN ; i++ )
		{
			switch( get_id(i) )
			{
			case	0:	id=0;	w++;	break;
			case	1:	id=1;	w++;	break;
			default:					continue;
			}
			sn = i;
		}
		if( w >= 2 )
		{
			msgbox("idset-result","ERROR!! TSC-xx must need one!",MB_OK,&mpt);
			return;
		}
		else if( sn == -1 )
		{
			msgbox("idset-result","ERROR!! TSC-xx not found!",MB_OK,&mpt);
			return;
		}
		snum = sn;
	}
	memset(btnum,-1,sizeof(btnum));
	get_display_rect(&r);
	printf("snum %d ,dispay (%d,%d)-(%d,%d)\n",snum,r.x,r.y,r.width,r.height);
	w = win_w = 200;
	h = win_h = 80;
	x = 100;
	y = (r.height/4) - (h/2);
	lineh = 18;
	set_rect(&r,x,y,w,h);
	//fgcolor = BlackPixel(sDisp,snum);
	fgcolor = get_color(0,0,0);
	bgcolor = get_color(0xe000,0xe000,0xe000);
	sprintf(s,"%s idset",ProductName);
	win = new_window(&r,s,fgcolor,bgcolor,false);
	// +-----------------------------+
	// | Panel ID Setting +--------+ |
	// |   id=0           |  set   | |
	// |   id=1           +--------+ |
	// +-----------------------------+
	XMoveWindow(sDisp,win->win,x,y);
	XFlush(sDisp);
	get_win_grect(&r,win);
printf("snum %d ,dispay (%d,%d)-(%d,%d) (%d,%d)\n",snum,r.x,r.y,r.width,r.height,x,y);
	mpt.x = r.x+10;
	mpt.y = r.y+10;
	x = (w/2) - ((w-10)/2);
	y1 = y = 5;
	w -= 10;
	h = lineh+5;
	ctlnum = 0;
	strcpy(s,idstr[ctlnum]);
	ww = w = get_text_width(win,s);
	set_rect(&r,x,y,w,h);
	ctl[ctlnum++] = new_control(win,PT_STEXT,s,&r,STATE_LEFT,0);
	strcpy(s,idstr[ctlnum]);
	x = x + (w/2) - (ww/2);
	y += (lineh + 5);
	set_rect(&r,x,y,ww,h);
	ctl[ctlnum++] = new_control(win,PT_RADIO,s,&r,(id==0?STATE_ON:STATE_OFF),1);
	strcpy(s,idstr[ctlnum]);
	y += (lineh + 5);
	set_rect(&r,x,y,ww,h);
	ctl[ctlnum++] = new_control(win,PT_RADIO,s,&r,(id==1?STATE_ON:STATE_OFF),1);

	y += (lineh + 5);
	h = y - y1;
	y = y1;
	w = ww;
	while( (x+ww+10+w+10) > win_w )
		w -= 10;
	x = x + ww + 10;
	set_rect(&r,x,y+5,w,h-5);
	btnum[BTNUM_APPLY] = ctlnum;
	ctl[ctlnum++] = new_control(win,PT_BUTTON,"Set",&r,STATE_OFF,0);
	ctl[ctlnum] = NULL;
	XSelectInput(sDisp,win->win,NormalMask);
	draw_control(ctl,ctlnum);
	for( end=false ; !end ; )
	{
		XNextEvent(sDisp,&ev);
		switch( ev.type )
		{
		case	KeyPress:
			if( XLookupString(&ev.xkey,s,10,&key,NULL) >= 1 )
			{
				switch( s[0] )
				{
				case 0x1b:	// ESC
				case 'e': end = true;		break;
				}
			}
			break;
		case	ButtonPress:
			ctl_mouse_on(ctl,ctlnum,&ev);
			break;
		case	ButtonRelease:
			if( (i = ctl_mouse_off(ctl,ctlnum,&ev)) == -1 )
				break;
			if( i == btnum[BTNUM_APPLY] )		// apply button
			{
				i = find_radio_group_on(ctl,ctlnum,1);
				if( set_id(snum,i-1) == -1 )
					msgbox("idset-result","Panel ID Set ERROR!!",MB_OK,&mpt);
				else
				{
					usleep(500*1000);
					if( get_id(snum) != (i-1) )
						msgbox("idset-result","Panel ID Check ERROR!!",MB_OK,&mpt);
				#if TEST_RMMOD
					else if( !reinit_mod() )
						msgbox("idset-result","Panel ID Reinit device ERROR!!",MB_OK,&mpt);
				#endif
					else if( path == NULL )
						msgbox("idset-result","Panel ID Set OK!! Please PNP TSC-XX!!",MB_OK,&mpt);
					else
						msgbox("idset-result","Panel ID Set OK!!",MB_OK,&mpt);
				}
				end = true;
			}
			break;
		case	MotionNotify:
		case	LeaveNotify:
			break;
		case	Expose:	/* = window draw */
			draw_control(ctl,ctlnum);
			break;
		case	ClientMessage:
			if( ev.xclient.message_type == win->a1 && ev.xclient.data.l[0] == win->a2 )
				end = true;
			break;
		case	DestroyNotify:
			end = true;
			break;
		}
	}
	destroy_window(win);
	term_ulib();
}
#if TEST_RMMOD
int reinit_mod()
{
int a;
char s[512];
	printf("reinit-module\n");
	if( path == NULL )
		return(true);
	sprintf(s,"/sbin/rmmod %s/usbdmc",path);
	if( (a = system(s)) == 0 )
	{
		printf("SUCCESS rmmod %s/usbdmc\n",path);
		sprintf(s,"/sbin/insmod %s/usbdmc.ko",path);
		if( (a = system(s)) == 0 )
		{
			printf("SUCCESS insmod %s/usbdmc.ko\n",path);
			return(true);
		}
		printf("ERROR(%d) insmod %s/usbdmc.ko\n",a,path);
	}
	else
		printf("ERROR(%d) rmmod %s/usbdmc\n",a,path);
	return(false);
}
#endif

